<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.4.549">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>r6</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
</style>


<script src="r6_files/libs/clipboard/clipboard.min.js"></script>
<script src="r6_files/libs/quarto-html/quarto.js"></script>
<script src="r6_files/libs/quarto-html/popper.min.js"></script>
<script src="r6_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="r6_files/libs/quarto-html/anchor.min.js"></script>
<link href="r6_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="r6_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="r6_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="r6_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="r6_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

<script type="text/javascript">
const typesetMath = (el) => {
  if (window.MathJax) {
    // MathJax Typeset
    window.MathJax.typeset([el]);
  } else if (window.katex) {
    // KaTeX Render
    var mathElements = el.getElementsByClassName("math");
    var macros = [];
    for (var i = 0; i < mathElements.length; i++) {
      var texText = mathElements[i].firstChild;
      if (mathElements[i].tagName == "SPAN") {
        window.katex.render(texText.data, mathElements[i], {
          displayMode: mathElements[i].classList.contains('display'),
          throwOnError: false,
          macros: macros,
          fleqn: false
        });
      }
    }
  }
}
window.Quarto = {
  typesetMath
};
</script>

</head>

<body class="fullcontent">

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">

<main class="content" id="quarto-document-content">




<div class="cell">
<style type="text/css">
.justify {
  text-align: justify !important
}
</style>
</div>
<section id="rekomendowane-metody-i-narzędzia-ukrywania-przekrojów-objętych-tajemnicą-statystyczną" class="level1">
<h1>Rekomendowane metody i narzędzia ukrywania przekrojów objętych tajemnicą statystyczną</h1>
<div class="justify">
<p>Wyraźnie należy podkreślić, że przedstawienie w jednym dokumencie szczegółowych rekomendacji dotyczących wszystkich badań, jakie są prowadzone w ramach programu badań statystycznych statystyki publicznej, nie jest możliwe. Wynika to przede wszystkim z bardzo dużej liczby tych badań oraz ich różnorodności i specyfiki, którą dogłębnie znają jedynie jednostki autorskie. W związku z tym w niniejszym rozdziale przyjęto ujęcie polegające na wyodrębnieniu pewnych typów badań i wskazaniu, na podstawie wyników przeprowadzonych prac Zespołu, rekomendacji w zakresie metod i narzędzi służących ochronie tajemnicy statystycznej. Wyodrębniono trzy główne typy badań prowadzone przez statystykę publiczną:</p>
<ul>
<li>spisy powszechne (Narodowy Spis Powszechny Ludności i Mieszkań, Powszechny Spis Rolny),</li>
<li>badania gospodarcze,</li>
<li>badania społeczne.</li>
</ul>
<p>Dodatkowo w ramach każdej typologii wyodrębniono dwie podstawowe formy przedstawiania wyników badania, w stosunku do których wymagana jest ochrona tajemnicy statystycznej, tzn. dane jednostkowe (mikrodane) i dane zagregowane (dane tabelaryczne)<a href="#fn1" class="footnote-ref" id="fnref1" role="doc-noteref"><sup>1</sup></a>. Takie ujęcie wydaje się rozsądnym kompromisem pomiędzy dążeniem do zachowania uniwersalności podejścia do ochrony tajemnicy statystycznej w całym resorcie statystyki publicznej, a z drugiej strony pozwala zwrócić uwagę na odrębność podejścia do ochrony tajemnicy statystycznej np. w przypadku badania podmiotów gospodarczych i ważnego aspektu danych statystycznych charakteryzujących wyniki ekonomiczno-finansowe zapisanych wprost w art. 38 ust. 2 Ustawy. Z kolei np. w odniesieniu do spisów powszechnych ich skala, obszerność, ale także międzynarodowe znaczenie skutkują tym, że pojawiają się określone postulaty zastosowania ujednoliconych i z góry ustalonych metod ochrony tajemnicy statystycznej, formułowane np. przez Eurostat czy UNECE.</p>
<section id="rekomendacje-dotyczące-organizacji-statystyki-publicznej-i-jej-infrastruktury-w-odniesieniu-do-ochrony-tajemnicy-statystycznej" class="level2">
<h2 class="anchored" data-anchor-id="rekomendacje-dotyczące-organizacji-statystyki-publicznej-i-jej-infrastruktury-w-odniesieniu-do-ochrony-tajemnicy-statystycznej">Rekomendacje dotyczące organizacji statystyki publicznej i jej infrastruktury w odniesieniu do ochrony tajemnicy statystycznej</h2>
<section id="infrastruktura-informatyczna-w-budowie-zintegrowanego-systemu-produkcji-danych-statystycznych-z-uwzględnieniem-ochrony-tajemnicy-statystycznej" class="level3">
<h3 class="anchored" data-anchor-id="infrastruktura-informatyczna-w-budowie-zintegrowanego-systemu-produkcji-danych-statystycznych-z-uwzględnieniem-ochrony-tajemnicy-statystycznej">Infrastruktura informatyczna w budowie zintegrowanego systemu produkcji danych statystycznych z uwzględnieniem ochrony tajemnicy statystycznej</h3>
<p>Rekomendacje dotyczące narzędzi informatycznych służących ochronie tajemnicy statystycznej zaprezentowane w dalszej części opracowania są ściśle powiązane z dostępną infrastrukturą informatyczną i jej funkcjonalnością. Składają się na to następujące zagadnienia:</p>
<ul>
<li><p>stworzenie centralnego zestawu aplikacji w ramach struktur informatycznych statystyki publicznej ABM, OBM<a href="#fn2" class="footnote-ref" id="fnref2" role="doc-noteref"><sup>2</sup></a>, zawierającego następujący minimalny zestaw narzędzi informatycznych służących automatyzacji ochrony tajemnicy statystycznej:</p>
<ul>
<li><span class="math inline">\(\mu\)</span>–Argus, <span class="math inline">\(\tau\)</span>–Argus,</li>
<li>środowisko R (w tym nakładka R-Studio),</li>
<li>SAS,</li>
<li>Python,</li>
</ul></li>
</ul>
<p>oraz zapewnienie użytkownikom możliwości aktualizowania pakietów (m. in. R oraz Python) na bieżąco,</p>
<ul>
<li>zaimplementowanie narzędzi wspierających proces kontroli ujawniania danych statystycznych w systemie SPDS.</li>
</ul>
</section>
<section id="rozwój-kompetencji-osób-zajmujących-się-metodami-kontroli-ujawniania-danych-statystycznych" class="level3">
<h3 class="anchored" data-anchor-id="rozwój-kompetencji-osób-zajmujących-się-metodami-kontroli-ujawniania-danych-statystycznych">Rozwój kompetencji osób zajmujących się metodami kontroli ujawniania danych statystycznych</h3>
<p>Rozwój kompetencji pracowników służb statystyki publicznej w zakresie poszerzania wiedzy na temat tajemnicy statystycznej oraz metod kontroli ujawniania danych powinien obejmować różne elementy w zależności od specyfiki wykonywanych działań.</p>
<p>Co do zasady wszyscy pracownicy statystyki publicznej – w ramach części obligatoryjnej służby przygotowawczej do służby cywilnej (nowo zatrudnione osoby) – powinni zapoznać się z materiałem <em>Poufność a użyteczność danych wynikowych w statystyce publicznej</em><a href="#fn3" class="footnote-ref" id="fnref3" role="doc-noteref"><sup>3</sup></a>, przygotowanym przez członków Zespołu z Urzędu Statystycznego w Poznaniu oraz Departamentu Programowania, Koordynacji Badań i Rejestrów GUS. Obejmuje on podstawowe zagadnienia związane z rozumieniem pojęć:</p>
<ul>
<li>tajemnicy statystycznej,</li>
<li>anonimizacji i pseudonimizacji,</li>
<li>kontroli ujawniania danych statystycznych,</li>
<li>kontroli ujawniania danych jednostkowych,</li>
<li>kontroli ujawniania w tablicach statystycznych,</li>
<li>kontroli ujawniania wyników analiz.</li>
</ul>
<p>Osoby, których zadania związane są bezpośrednio z kwestiami ochrony tajemnicy statystycznej, czy to na etapie fazy projektowania badania (faza 2. MPPS), czy na etapie analizy (faza 6. MPPS), powinny mieć możliwość uczestniczenia w szkoleniach wewnętrznych lub zewnętrznych (w tym zagranicznych) przybliżających aspekty prawne, metodologiczne i narzędziowe SDC. Specjalistyczne szkolenia wewnętrzne z zakresu SDC powinny być umieszczone w programie szkoleń wewnętrznych GUS, a osoby przygotowujące materiały i zaangażowane w prowadzenie szkoleń z tego zakresu powinny wejść w skład programu trenerów wewnętrznych. Osoby takie winny również posiadać zapewniony dostęp do literatury światowej z tego zakresu. W pierwszym rzędzie dotyczy to monografii i artykułów publikowanych w licencjonowanym dostępie. Umożliwi to stały rozwój i doskonalenie narzędzi kontroli ujawniania danych w statystyce publicznej.</p>
</section>
</section>
<section id="schemat-procesu-kontroli-ujawniania-danych" class="level2">
<h2 class="anchored" data-anchor-id="schemat-procesu-kontroli-ujawniania-danych">Schemat procesu kontroli ujawniania danych<a href="#fn4" class="footnote-ref" id="fnref4" role="doc-noteref"><sup>4</sup></a></h2>
<p>Poniższy schemat dotyczy postępowania z danymi jednostkowymi i składa się z czterech etapów: oceny pozyskanych danych jednostkowych, zaplanowania procesu SDC, wdrożenia etapu SDC oraz udostępniania danych z ochroną tajemnicy statystycznej. Z jednej strony zaproponowany schemat ma walor ogólności i może być dostosowywany do specyfiki konkretnego badania realizowanego przez daną jednostkę autorską, z drugiej natomiast – poprzez kompleksowe ujęcie procesu SDC – pozwala dostosować ten proces i skoncentrować się na tych działaniach i aspektach, które w danym badaniu są kluczowe.</p>
<p><strong>Etap 1. Ocena pozyskanych danych jednostkowych</strong></p>
<ol type="1">
<li>Zebranie informacji o zmiennych zawartych w zbiorze
<ol type="a">
<li>pozyskanie metadanych o wszystkich zmiennych występujących w zbiorze danych,</li>
<li>identyfikacja zmiennych kategorialnych (z podziałem na dane nominalne i porządkowe) oraz ciągłych.</li>
</ol></li>
<li>Wskazanie zmiennych zawężonych do określonej podpopulacji
<ol type="a">
<li>ustalenie hierarchii (np. przekrojów) i struktury zawężeń (zmiennych, które dotyczą wyłącznie określonych podzbiorów zbioru jednostek),</li>
<li>identyfikacja warunków określających podpopulacje (podzbiory), których dotyczą informacje zawarte w tych zmiennych.</li>
</ol></li>
<li>Ocena skali braków danych (w tym tych mogących wpływać na ochronę tajemnicy statystycznej) oraz zakresu imputacji jeżeli została przeprowadzona
<ol type="a">
<li>wyznaczenie liczby i struktury braków danych,</li>
<li>ustalenie sposobu traktowania braków danych z punktu widzenia zapewnienia ochrony tajemnicy statystycznej (np. pominięcie, traktowanie jako zera, uwzględnienie w wyznaczaniu częstości w wszystkich lub niektórych przekrojach albo wcale).</li>
</ol></li>
</ol>
<p><strong>Etap 2. Zaplanowanie procesu SDC</strong></p>
<ol type="1">
<li>Ocena potrzeby zachowania poufności
<ol type="a">
<li>sprawdzenie, czy w zbiorze występują zmienne bezpośrednio identyfikujące respondentów oraz czy zachodzi możliwość identyfikacji pośredniej,</li>
<li>identyfikacja zbioru jednostek statystycznych, o których informacje znajdują się w danych jednostkowych i ich rodzajów (osoby fizyczne, gospodarstwa domowe, przedsiębiorstwa, itp.),</li>
<li>identyfikacja hierarchii występujących w danych (zwłaszcza w kontekście przestrzennym czy względem wybranych cech).</li>
</ol></li>
<li>Przygotowanie zbioru danych jednostkowych i przegląd ich kluczowych właściwości z punktu widzenia SDC
<ol type="a">
<li>identyfikacja typu zmiennych z punktu widzenia SDC, w tym w oparciu o wyniki Etapu 1. (identyfikatory, quasi-identyfikatory, zmienne wrażliwe, zmienne niewrażliwe, zmienne kategorialne, zmienne ciągłe, zmienne ważące, zmienne hierarchiczne, zmienne regionalne, zmienne kartograficzne),</li>
<li>usunięcie identyfikatorów.</li>
</ol></li>
<li>Określenie lub weryfikacja wcześniej zaplanowanego typu udostępnienia danych
<ol type="a">
<li>ustalenie czy udostępnienie danych nastąpi w formie danych jednostkowych czy w formie zagregowanej (względnie w obydwu postaciach),</li>
<li>określenie, które zmienne z przyczyn innych niż związanych z ochroną tajemnicy statystycznej na pewno nie będą udostępnione,</li>
<li>wskazanie zmiennych przeznaczonych do udostępnienia w formie zagregowanej i określenie układów tablic wynikowych.</li>
</ol></li>
<li>Wybór miar ryzyka ujawnienia informacji poufnych
<ol type="a">
<li>określenie obszarów występowania ryzyka ujawnienia atrybutu (cechy) lub tożsamości (identyfikacja),</li>
<li>dobór miar przydatnych dla oceny ryzyka w przypadku zmiennych kategorialnych i ciągłych, z uwzględnieniem reguł określonych obowiązującymi przepisami; w miarę możliwości powinny się tu znaleźć także miary ryzyka indywidualnego, globalnego i hierarchicznego oraz wpływu poszczególnych zmiennych na poziom ryzyka identyfikacji jednostki.</li>
</ol></li>
<li>Wybór metod kontroli ujawniania danych
<ol type="a">
<li>wskazanie zmiennych, w których dane będą ukrywane (a więc zastosowanie znajdą metody niezakłóceniowe) oraz zmiennych, których dane będą zniekształcane (wykorzystanie metod zakłóceniowych),</li>
<li>ustalenie czy stosowane metody będą miały charakter deterministyczny czy probabilistyczny,</li>
<li>wybór konkretnych metod spośród dostępnych podejść,</li>
<li>określenie parametryzacji wybranych metod.</li>
</ol></li>
<li>Wybór miar straty informacji ponoszonej wskutek nakładania tajemnicy statystycznej
<ol type="a">
<li>dobór miar poziomu zakłócenia rozkładu w przypadku zmiennych kategorialnych,</li>
<li>dobór miar poziomu zakłócenia rozkładu, wpływu na wariancję szacunków oraz wpływu na siłę związku (w kontekście korelacji) dla zmiennych ciągłych,</li>
<li>określenie globalnej straty informacji (ogółem i dla poszczególnych zmiennych).</li>
</ol></li>
</ol>
<p><strong>Etap 3. Wdrożenie procesu SDC</strong></p>
<ol type="1">
<li><p>Przeprowadzenie procesu kontroli ujawniania danych wedle zasad określonych w Etapie 2.</p></li>
<li><p>Ocena efektywności zastosowanych rozwiązań, w tym pod kątem balansu między minimalizacją ryzyka ujawnienia a minimalizacją straty informacji na skutek SDC</p>
<ol type="a">
<li>sprawdzenie czy jeden z tych aspektów nie przeważa zbytnio nad drugim,</li>
<li>modyfikacja zastosowanych metod lub ich parametryzacja w razie potrzeby i ponowienie procesu.</li>
</ol></li>
</ol>
<p><strong>Etap 4. Udostępnianie danych jednostkowych nieidentyfikowalnych z ochroną tajemnicy statystycznej</strong><a href="#fn5" class="footnote-ref" id="fnref5" role="doc-noteref"><sup>5</sup></a></p>
<ol type="1">
<li><p>Określenie formy, w jakiej dane mają być udostępniane.</p></li>
<li><p>Ustalenie niezbędnych informacji przekazywanych użytkownikowi razem z danymi.</p></li>
<li><p>Organizacja udostępniania danych i ewentualnej powtarzalności procesu SDC zgodnie z obowiązującymi w GUS zasadami, m.in. <em>Polityką postępowania z danymi statystycznymi, Zarządzeniem wewnętrznym nr 2 Dyrektora Centrum Informatyki Statystycznej z dnia 12 marca 2018 r. w sprawie wprowadzenia Polityki bezpieczeństwa teleinformatycznego i Polityki bezpieczeństwa teleinformatycznego przetwarzania mikrodanych wymienianych pomiędzy Państwami członkowskimi Unii Europejskiej, oraz uchylenia niektórych zarządzeń dotyczących bezpieczeństwa informacji</em> .</p></li>
</ol>
</section>
<section id="rekomendacje-w-zakresie-metod-i-narzędzi-informatycznych-ochrony-tajemnicy-statystycznej" class="level2">
<h2 class="anchored" data-anchor-id="rekomendacje-w-zakresie-metod-i-narzędzi-informatycznych-ochrony-tajemnicy-statystycznej">Rekomendacje w zakresie metod i narzędzi informatycznych ochrony tajemnicy statystycznej</h2>
<p>Na podstawie doświadczeń zebranych przez Zespół w ramach wykonanych prac, poniżej zaprezentowano macierz zawierającą rekomendacje w zakresie narzędzi i metod dopasowanych do rodzajów badań statystycznych oraz dwóch podstawowych typów danych (danych jednostkowych i danych zagregowanych). Informacje statystyczne, oprócz wymienionych powyżej podstawowych typów danych, mogą być także udostępniane w postaci wykresów, map, modeli statystycznych, wyników analiz oraz tym podobnych. Należy podkreślić, że ochrona tajemnicy statystycznej ma zastosowanie do wszystkich typów publikowanych informacji przez urzędy statystyczne w takim samym zakresie – jak zauważa Eurostat w swoim podręczniku z zakresu statystyki gospodarczej European Business Statistics Manual – dynamic edition (por. Eurostat, 2021 s. 186) – zastosowanie metod SDC powinno być spójne, wziąwszy pod uwagę powiązania między danymi. Spójność powinna być zapewniona pomiędzy powiązanymi tablicami, a także pomiędzy różnymi sposobami prezentacji danych statystycznych. Należy jednak zauważyć, że automatyzacja metod SDC w odniesieniu do danych jednostkowych i danych zagregowanych jest dużo łatwiejsza, bowiem powstały dedykowane tym typom danych metody i narzędzia ułatwiające tę ochronę. Natomiast w przypadku danych w postaci wykresów, map, modeli statystycznych czy wyników analiz zapewnienie ochrony tajemnicy statystycznej ma najczęściej „ręczny charakter”. Jako pewne generalne podejście do tego typu danych można wskazać rekomendacje zawarte w Podręczniku SDC dla różnych typów informacji wynikowych (por. Handbook on Statistical Disclosure Control for Outputs, Griffiths i in., 2019, s. 35), które wyraźnie wskazują, że wykresy podlegają tej samej metodologii SDC co tablice statystyczne (dane zagregowane). Najłatwiejszym sposobem sprawdzenia wykresów statystycznych jest zastosowanie metod SDC dla tablic, na podstawie których zostały wykonane.</p>
<p>Z powyższych względów poniżej wymieniono metody i narzędzia ochrony tajemnicy statystycznej dla danych zagregowanych (tablice statystyczne) i danych jednostkowych (mikrodanych). Rekomendowane metody i narzędzia dla badań gospodarczych opracowano na podstawie analiz przeprowadzonych dla badań P-01 (Sprawozdanie o produkcji) i F-01/I-01 (Sprawozdanie o przychodach, kosztach i wyniku finansowym oraz o nakładach na środki trwałe), a dla badań społecznych na podstawie Badania Aktywności Ekonomicznej Ludności i Badania Kształcenia Dorosłych. Niektóre z pakietów, o których poniżej jest mowa, obejmują także określone metody oceny ryzyka oraz pomiaru straty informacji, jednak szczegóły na temat tych metod i stosowne rekomendacje zostaną przedstawione w innych częściach Przewodnika.</p>
</section>
</div>
</section>


<div id="quarto-appendix" class="default"><section id="footnotes" class="footnotes footnotes-end-of-document" role="doc-endnotes"><h2 class="anchored quarto-appendix-heading">Footnotes</h2>

<ol>
<li id="fn1"><p>Rekomendacje dotyczące ochrony tajemnicy statystycznej w przypadku innego ujęcia danych, np. prezentowanych w formie graficznej (mapy, wykresy), są zawarte w innym opracowaniu.<a href="#fnref1" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
<li id="fn2"><p>Rekomendacje nie obejmują Systemów Informatycznych Badań, które mają swoją odrębną specyfikę i są w gestii jednostek autorskich badań bądź jednostek naliczających dane. W przypadku kiedy System Informatyczny Badania nie zawiera określonych narzędzi albo implementacji metod kontroli ujawniania wyników, powinna być możliwość bezpiecznego transferu danych z badania do środowiska (OBM, ABM), w którym takie narzędzia będą dostępne.<a href="#fnref2" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
<li id="fn3"><p>Materiał dostępny pod linkiem <a href="http://intranet/GUS/BOK/Suba%20przygotowawcza/Cz%C4%99%C5%9B%C4%87%20obligatoryjna%20-%20materia%C5%82y%20szkoleniowe/Zasady%20organizacji%20bada%C5%84%20statystycznych_2024%20PR/Poufno%C5%9B%C4%87%20a%20u%C5%BCyteczno%C5%9B%C4%87%20danych%20wynikowych%202024.pptx">Strony - Służba Przygotowawcza</a><a href="#fnref3" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
<li id="fn4"><p>Opracowano na podstawie wyników pracy metodologicznej pt.&nbsp;Kontrola ujawniania danych w badaniu wypadków przy pracy. Materiał dostępny pod linkiem - <a href="http://intranet/GUS/PK/MB/Lists/Opracowania%20z%20prac%20metodologicznych/DispForm.aspx?ID=31&amp;Source=http%3A%2F%2Fintranet%2FGUS%2FPK%2FMB%2FLists%2FOpracowania%2520z%2520prac%2520metodologicznych%2FAllItems%2Easpx&amp;ContentTypeId=0x0100E409BC9F533D99449014A50DA799544900FC69C217E2BECC49B4D89305F7720388">Raport z pracy metodologicznej 3.253 “Kontrola ujawniania danych w badaniu wypadków przy pracy”</a><a href="#fnref4" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
<li id="fn5"><p>Por. <em>Polityka postępowania z danymi statystycznymi</em>, rozdział VI. F. Fazy – UDOSTĘPNIANIE.<a href="#fnref5" class="footnote-back" role="doc-backlink">↩︎</a></p></li>
</ol>
</section></div></main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->




</body></html>